
package es.gob.administracion.punto_unico_notificaciones.consultaanexos;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * &lt;p&gt;Clase Java para ConsultaAnexos complex type.
 * 
 * &lt;p&gt;El siguiente fragmento de esquema especifica el contenido que se espera que haya en esta clase.
 * 
 * &lt;pre&gt;
 * &amp;lt;complexType name="ConsultaAnexos"&amp;gt;
 *   &amp;lt;complexContent&amp;gt;
 *     &amp;lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&amp;gt;
 *       &amp;lt;sequence&amp;gt;
 *         &amp;lt;element name="nifReceptor" type="{http://administracion.gob.es/punto-unico-notificaciones/consultaAnexos}Nif"/&amp;gt;
 *         &amp;lt;element name="identificador" type="{http://administracion.gob.es/punto-unico-notificaciones/consultaAnexos}Identificador"/&amp;gt;
 *         &amp;lt;element name="codigoOrigen" type="{http://www.w3.org/2001/XMLSchema}integer"/&amp;gt;
 *         &amp;lt;element name="referencia" type="{http://www.w3.org/2001/XMLSchema}base64Binary"/&amp;gt;
 *         &amp;lt;element name="opcionesConsultaAnexos" type="{http://administracion.gob.es/punto-unico-notificaciones/consultaAnexos}Opciones" minOccurs="0"/&amp;gt;
 *       &amp;lt;/sequence&amp;gt;
 *     &amp;lt;/restriction&amp;gt;
 *   &amp;lt;/complexContent&amp;gt;
 * &amp;lt;/complexType&amp;gt;
 * &lt;/pre&gt;
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ConsultaAnexos", propOrder = {
    "nifReceptor",
    "identificador",
    "codigoOrigen",
    "referencia",
    "opcionesConsultaAnexos"
})
public class ConsultaAnexos implements Equals, ToString
{

    @XmlElement(required = true)
    protected String nifReceptor;
    @XmlElement(required = true)
    protected String identificador;
    @XmlElement(required = true)
    protected BigInteger codigoOrigen;
    @XmlElement(required = true)
    protected byte[] referencia;
    @XmlElementWrapper
    @XmlElement(name = "opcion", namespace = "http://administracion.gob.es/punto-unico-notificaciones/consultaAnexos")
    protected List<Opcion> opcionesConsultaAnexos;

    /**
     * Obtiene el valor de la propiedad nifReceptor.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getNifReceptor() {
        return nifReceptor;
    }

    /**
     * Define el valor de la propiedad nifReceptor.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setNifReceptor(String value) {
        this.nifReceptor = value;
    }

    /**
     * Obtiene el valor de la propiedad identificador.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getIdentificador() {
        return identificador;
    }

    /**
     * Define el valor de la propiedad identificador.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setIdentificador(String value) {
        this.identificador = value;
    }

    /**
     * Obtiene el valor de la propiedad codigoOrigen.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getCodigoOrigen() {
        return codigoOrigen;
    }

    /**
     * Define el valor de la propiedad codigoOrigen.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setCodigoOrigen(BigInteger value) {
        this.codigoOrigen = value;
    }

    /**
     * Obtiene el valor de la propiedad referencia.
     * 
     * @return
     *     possible object is
     *     byte[]
     */
    public byte[] getReferencia() {
        return referencia;
    }

    /**
     * Define el valor de la propiedad referencia.
     * 
     * @param value
     *     allowed object is
     *     byte[]
     */
    public void setReferencia(byte[] value) {
        this.referencia = value;
    }

    public List<Opcion> getOpcionesConsultaAnexos() {
        if (opcionesConsultaAnexos == null) {
            opcionesConsultaAnexos = new ArrayList<Opcion>();
        }
        return opcionesConsultaAnexos;
    }

    public void setOpcionesConsultaAnexos(List<Opcion> opcionesConsultaAnexos) {
        this.opcionesConsultaAnexos = opcionesConsultaAnexos;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof ConsultaAnexos)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        final ConsultaAnexos that = ((ConsultaAnexos) object);
        {
            String lhsNifReceptor;
            lhsNifReceptor = this.getNifReceptor();
            String rhsNifReceptor;
            rhsNifReceptor = that.getNifReceptor();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "nifReceptor", lhsNifReceptor), LocatorUtils.property(thatLocator, "nifReceptor", rhsNifReceptor), lhsNifReceptor, rhsNifReceptor)) {
                return false;
            }
        }
        {
            String lhsIdentificador;
            lhsIdentificador = this.getIdentificador();
            String rhsIdentificador;
            rhsIdentificador = that.getIdentificador();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "identificador", lhsIdentificador), LocatorUtils.property(thatLocator, "identificador", rhsIdentificador), lhsIdentificador, rhsIdentificador)) {
                return false;
            }
        }
        {
            BigInteger lhsCodigoOrigen;
            lhsCodigoOrigen = this.getCodigoOrigen();
            BigInteger rhsCodigoOrigen;
            rhsCodigoOrigen = that.getCodigoOrigen();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "codigoOrigen", lhsCodigoOrigen), LocatorUtils.property(thatLocator, "codigoOrigen", rhsCodigoOrigen), lhsCodigoOrigen, rhsCodigoOrigen)) {
                return false;
            }
        }
        {
            byte[] lhsReferencia;
            lhsReferencia = this.getReferencia();
            byte[] rhsReferencia;
            rhsReferencia = that.getReferencia();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "referencia", lhsReferencia), LocatorUtils.property(thatLocator, "referencia", rhsReferencia), lhsReferencia, rhsReferencia)) {
                return false;
            }
        }
        {
            List<Opcion> lhsOpcionesConsultaAnexos;
            lhsOpcionesConsultaAnexos = ((this.opcionesConsultaAnexos!= null)?this.getOpcionesConsultaAnexos():null);
            List<Opcion> rhsOpcionesConsultaAnexos;
            rhsOpcionesConsultaAnexos = ((that.opcionesConsultaAnexos!= null)?that.getOpcionesConsultaAnexos():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "opcionesConsultaAnexos", lhsOpcionesConsultaAnexos), LocatorUtils.property(thatLocator, "opcionesConsultaAnexos", rhsOpcionesConsultaAnexos), lhsOpcionesConsultaAnexos, rhsOpcionesConsultaAnexos)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        {
            String theNifReceptor;
            theNifReceptor = this.getNifReceptor();
            strategy.appendField(locator, this, "nifReceptor", buffer, theNifReceptor);
        }
        {
            String theIdentificador;
            theIdentificador = this.getIdentificador();
            strategy.appendField(locator, this, "identificador", buffer, theIdentificador);
        }
        {
            BigInteger theCodigoOrigen;
            theCodigoOrigen = this.getCodigoOrigen();
            strategy.appendField(locator, this, "codigoOrigen", buffer, theCodigoOrigen);
        }
        {
            byte[] theReferencia;
            theReferencia = this.getReferencia();
            strategy.appendField(locator, this, "referencia", buffer, theReferencia);
        }
        {
            List<Opcion> theOpcionesConsultaAnexos;
            theOpcionesConsultaAnexos = ((this.opcionesConsultaAnexos!= null)?this.getOpcionesConsultaAnexos():null);
            strategy.appendField(locator, this, "opcionesConsultaAnexos", buffer, theOpcionesConsultaAnexos);
        }
        return buffer;
    }

}
