
package es.gob.administracion.punto_unico_notificaciones.peticionacceso;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * &lt;p&gt;Clase Java para PeticionAcceso complex type.
 * 
 * &lt;p&gt;El siguiente fragmento de esquema especifica el contenido que se espera que haya en esta clase.
 * 
 * &lt;pre&gt;
 * &amp;lt;complexType name="PeticionAcceso"&amp;gt;
 *   &amp;lt;complexContent&amp;gt;
 *     &amp;lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&amp;gt;
 *       &amp;lt;sequence&amp;gt;
 *         &amp;lt;element name="identificador" type="{http://administracion.gob.es/punto-unico-notificaciones/peticionAcceso}Identificador"/&amp;gt;
 *         &amp;lt;element name="codigoOrigen" type="{http://www.w3.org/2001/XMLSchema}integer"/&amp;gt;
 *         &amp;lt;element name="nifReceptor" type="{http://administracion.gob.es/punto-unico-notificaciones/peticionAcceso}Nif"/&amp;gt;
 *         &amp;lt;element name="nombreReceptor" type="{http://www.w3.org/2001/XMLSchema}string"/&amp;gt;
 *         &amp;lt;element name="evento" type="{http://administracion.gob.es/punto-unico-notificaciones/peticionAcceso}Evento"/&amp;gt;
 *         &amp;lt;element name="concepto" type="{http://administracion.gob.es/punto-unico-notificaciones/peticionAcceso}Concepto"/&amp;gt;
 *         &amp;lt;element name="opcionesPeticionAcceso" type="{http://administracion.gob.es/punto-unico-notificaciones/peticionAcceso}Opciones" minOccurs="0"/&amp;gt;
 *       &amp;lt;/sequence&amp;gt;
 *     &amp;lt;/restriction&amp;gt;
 *   &amp;lt;/complexContent&amp;gt;
 * &amp;lt;/complexType&amp;gt;
 * &lt;/pre&gt;
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "PeticionAcceso", propOrder = {
    "identificador",
    "codigoOrigen",
    "nifReceptor",
    "nombreReceptor",
    "evento",
    "concepto",
    "opcionesPeticionAcceso"
})
public class PeticionAcceso implements Equals, ToString
{

    @XmlElement(required = true)
    protected String identificador;
    @XmlElement(required = true)
    protected BigInteger codigoOrigen;
    @XmlElement(required = true)
    protected String nifReceptor;
    @XmlElement(required = true)
    protected String nombreReceptor;
    @XmlElement(required = true)
    protected String evento;
    @XmlElement(required = true)
    protected String concepto;
    @XmlElementWrapper
    @XmlElement(name = "opcion", namespace = "http://administracion.gob.es/punto-unico-notificaciones/peticionAcceso")
    protected List<Opcion> opcionesPeticionAcceso;

    /**
     * Obtiene el valor de la propiedad identificador.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getIdentificador() {
        return identificador;
    }

    /**
     * Define el valor de la propiedad identificador.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setIdentificador(String value) {
        this.identificador = value;
    }

    /**
     * Obtiene el valor de la propiedad codigoOrigen.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getCodigoOrigen() {
        return codigoOrigen;
    }

    /**
     * Define el valor de la propiedad codigoOrigen.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setCodigoOrigen(BigInteger value) {
        this.codigoOrigen = value;
    }

    /**
     * Obtiene el valor de la propiedad nifReceptor.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getNifReceptor() {
        return nifReceptor;
    }

    /**
     * Define el valor de la propiedad nifReceptor.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setNifReceptor(String value) {
        this.nifReceptor = value;
    }

    /**
     * Obtiene el valor de la propiedad nombreReceptor.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getNombreReceptor() {
        return nombreReceptor;
    }

    /**
     * Define el valor de la propiedad nombreReceptor.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setNombreReceptor(String value) {
        this.nombreReceptor = value;
    }

    /**
     * Obtiene el valor de la propiedad evento.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getEvento() {
        return evento;
    }

    /**
     * Define el valor de la propiedad evento.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setEvento(String value) {
        this.evento = value;
    }

    /**
     * Obtiene el valor de la propiedad concepto.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getConcepto() {
        return concepto;
    }

    /**
     * Define el valor de la propiedad concepto.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setConcepto(String value) {
        this.concepto = value;
    }

    public List<Opcion> getOpcionesPeticionAcceso() {
        if (opcionesPeticionAcceso == null) {
            opcionesPeticionAcceso = new ArrayList<Opcion>();
        }
        return opcionesPeticionAcceso;
    }

    public void setOpcionesPeticionAcceso(List<Opcion> opcionesPeticionAcceso) {
        this.opcionesPeticionAcceso = opcionesPeticionAcceso;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof PeticionAcceso)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        final PeticionAcceso that = ((PeticionAcceso) object);
        {
            String lhsIdentificador;
            lhsIdentificador = this.getIdentificador();
            String rhsIdentificador;
            rhsIdentificador = that.getIdentificador();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "identificador", lhsIdentificador), LocatorUtils.property(thatLocator, "identificador", rhsIdentificador), lhsIdentificador, rhsIdentificador)) {
                return false;
            }
        }
        {
            BigInteger lhsCodigoOrigen;
            lhsCodigoOrigen = this.getCodigoOrigen();
            BigInteger rhsCodigoOrigen;
            rhsCodigoOrigen = that.getCodigoOrigen();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "codigoOrigen", lhsCodigoOrigen), LocatorUtils.property(thatLocator, "codigoOrigen", rhsCodigoOrigen), lhsCodigoOrigen, rhsCodigoOrigen)) {
                return false;
            }
        }
        {
            String lhsNifReceptor;
            lhsNifReceptor = this.getNifReceptor();
            String rhsNifReceptor;
            rhsNifReceptor = that.getNifReceptor();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "nifReceptor", lhsNifReceptor), LocatorUtils.property(thatLocator, "nifReceptor", rhsNifReceptor), lhsNifReceptor, rhsNifReceptor)) {
                return false;
            }
        }
        {
            String lhsNombreReceptor;
            lhsNombreReceptor = this.getNombreReceptor();
            String rhsNombreReceptor;
            rhsNombreReceptor = that.getNombreReceptor();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "nombreReceptor", lhsNombreReceptor), LocatorUtils.property(thatLocator, "nombreReceptor", rhsNombreReceptor), lhsNombreReceptor, rhsNombreReceptor)) {
                return false;
            }
        }
        {
            String lhsEvento;
            lhsEvento = this.getEvento();
            String rhsEvento;
            rhsEvento = that.getEvento();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "evento", lhsEvento), LocatorUtils.property(thatLocator, "evento", rhsEvento), lhsEvento, rhsEvento)) {
                return false;
            }
        }
        {
            String lhsConcepto;
            lhsConcepto = this.getConcepto();
            String rhsConcepto;
            rhsConcepto = that.getConcepto();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "concepto", lhsConcepto), LocatorUtils.property(thatLocator, "concepto", rhsConcepto), lhsConcepto, rhsConcepto)) {
                return false;
            }
        }
        {
            List<Opcion> lhsOpcionesPeticionAcceso;
            lhsOpcionesPeticionAcceso = ((this.opcionesPeticionAcceso!= null)?this.getOpcionesPeticionAcceso():null);
            List<Opcion> rhsOpcionesPeticionAcceso;
            rhsOpcionesPeticionAcceso = ((that.opcionesPeticionAcceso!= null)?that.getOpcionesPeticionAcceso():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "opcionesPeticionAcceso", lhsOpcionesPeticionAcceso), LocatorUtils.property(thatLocator, "opcionesPeticionAcceso", rhsOpcionesPeticionAcceso), lhsOpcionesPeticionAcceso, rhsOpcionesPeticionAcceso)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        {
            String theIdentificador;
            theIdentificador = this.getIdentificador();
            strategy.appendField(locator, this, "identificador", buffer, theIdentificador);
        }
        {
            BigInteger theCodigoOrigen;
            theCodigoOrigen = this.getCodigoOrigen();
            strategy.appendField(locator, this, "codigoOrigen", buffer, theCodigoOrigen);
        }
        {
            String theNifReceptor;
            theNifReceptor = this.getNifReceptor();
            strategy.appendField(locator, this, "nifReceptor", buffer, theNifReceptor);
        }
        {
            String theNombreReceptor;
            theNombreReceptor = this.getNombreReceptor();
            strategy.appendField(locator, this, "nombreReceptor", buffer, theNombreReceptor);
        }
        {
            String theEvento;
            theEvento = this.getEvento();
            strategy.appendField(locator, this, "evento", buffer, theEvento);
        }
        {
            String theConcepto;
            theConcepto = this.getConcepto();
            strategy.appendField(locator, this, "concepto", buffer, theConcepto);
        }
        {
            List<Opcion> theOpcionesPeticionAcceso;
            theOpcionesPeticionAcceso = ((this.opcionesPeticionAcceso!= null)?this.getOpcionesPeticionAcceso():null);
            strategy.appendField(locator, this, "opcionesPeticionAcceso", buffer, theOpcionesPeticionAcceso);
        }
        return buffer;
    }

}
