
package es.gob.administracion.punto_unico_notificaciones.respuestaconsultaacusepdf;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * &lt;p&gt;Clase Java para RespuestaConsultaAcusePdf complex type.
 * 
 * &lt;p&gt;El siguiente fragmento de esquema especifica el contenido que se espera que haya en esta clase.
 * 
 * &lt;pre&gt;
 * &amp;lt;complexType name="RespuestaConsultaAcusePdf"&amp;gt;
 *   &amp;lt;complexContent&amp;gt;
 *     &amp;lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&amp;gt;
 *       &amp;lt;sequence&amp;gt;
 *         &amp;lt;element name="codigoRespuesta" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaConsultaAcusePdf}Codigo"/&amp;gt;
 *         &amp;lt;element name="descripcionRespuesta" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaConsultaAcusePdf}Descripcion"/&amp;gt;
 *         &amp;lt;element name="acusePdf" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaConsultaAcusePdf}AcusePdf" minOccurs="0"/&amp;gt;
 *         &amp;lt;element name="opcionesRespuestaConsultaAcusePdf" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaConsultaAcusePdf}Opciones" minOccurs="0"/&amp;gt;
 *       &amp;lt;/sequence&amp;gt;
 *     &amp;lt;/restriction&amp;gt;
 *   &amp;lt;/complexContent&amp;gt;
 * &amp;lt;/complexType&amp;gt;
 * &lt;/pre&gt;
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "RespuestaConsultaAcusePdf", propOrder = {
    "codigoRespuesta",
    "descripcionRespuesta",
    "acusePdf",
    "opcionesRespuestaConsultaAcusePdf"
})
public class RespuestaConsultaAcusePdf implements Equals, ToString
{

    @XmlElement(required = true)
    protected String codigoRespuesta;
    @XmlElement(required = true)
    protected String descripcionRespuesta;
    protected AcusePdf acusePdf;
    @XmlElementWrapper
    @XmlElement(name = "opcion", namespace = "http://administracion.gob.es/punto-unico-notificaciones/respuestaConsultaAcusePdf")
    protected List<Opcion> opcionesRespuestaConsultaAcusePdf;

    /**
     * Obtiene el valor de la propiedad codigoRespuesta.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getCodigoRespuesta() {
        return codigoRespuesta;
    }

    /**
     * Define el valor de la propiedad codigoRespuesta.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setCodigoRespuesta(String value) {
        this.codigoRespuesta = value;
    }

    /**
     * Obtiene el valor de la propiedad descripcionRespuesta.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getDescripcionRespuesta() {
        return descripcionRespuesta;
    }

    /**
     * Define el valor de la propiedad descripcionRespuesta.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setDescripcionRespuesta(String value) {
        this.descripcionRespuesta = value;
    }

    /**
     * Obtiene el valor de la propiedad acusePdf.
     * 
     * @return
     *     possible object is
     *     {@link AcusePdf }
     *     
     */
    public AcusePdf getAcusePdf() {
        return acusePdf;
    }

    /**
     * Define el valor de la propiedad acusePdf.
     * 
     * @param value
     *     allowed object is
     *     {@link AcusePdf }
     *     
     */
    public void setAcusePdf(AcusePdf value) {
        this.acusePdf = value;
    }

    public List<Opcion> getOpcionesRespuestaConsultaAcusePdf() {
        if (opcionesRespuestaConsultaAcusePdf == null) {
            opcionesRespuestaConsultaAcusePdf = new ArrayList<Opcion>();
        }
        return opcionesRespuestaConsultaAcusePdf;
    }

    public void setOpcionesRespuestaConsultaAcusePdf(List<Opcion> opcionesRespuestaConsultaAcusePdf) {
        this.opcionesRespuestaConsultaAcusePdf = opcionesRespuestaConsultaAcusePdf;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof RespuestaConsultaAcusePdf)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        final RespuestaConsultaAcusePdf that = ((RespuestaConsultaAcusePdf) object);
        {
            String lhsCodigoRespuesta;
            lhsCodigoRespuesta = this.getCodigoRespuesta();
            String rhsCodigoRespuesta;
            rhsCodigoRespuesta = that.getCodigoRespuesta();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "codigoRespuesta", lhsCodigoRespuesta), LocatorUtils.property(thatLocator, "codigoRespuesta", rhsCodigoRespuesta), lhsCodigoRespuesta, rhsCodigoRespuesta)) {
                return false;
            }
        }
        {
            String lhsDescripcionRespuesta;
            lhsDescripcionRespuesta = this.getDescripcionRespuesta();
            String rhsDescripcionRespuesta;
            rhsDescripcionRespuesta = that.getDescripcionRespuesta();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "descripcionRespuesta", lhsDescripcionRespuesta), LocatorUtils.property(thatLocator, "descripcionRespuesta", rhsDescripcionRespuesta), lhsDescripcionRespuesta, rhsDescripcionRespuesta)) {
                return false;
            }
        }
        {
            AcusePdf lhsAcusePdf;
            lhsAcusePdf = this.getAcusePdf();
            AcusePdf rhsAcusePdf;
            rhsAcusePdf = that.getAcusePdf();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "acusePdf", lhsAcusePdf), LocatorUtils.property(thatLocator, "acusePdf", rhsAcusePdf), lhsAcusePdf, rhsAcusePdf)) {
                return false;
            }
        }
        {
            List<Opcion> lhsOpcionesRespuestaConsultaAcusePdf;
            lhsOpcionesRespuestaConsultaAcusePdf = ((this.opcionesRespuestaConsultaAcusePdf!= null)?this.getOpcionesRespuestaConsultaAcusePdf():null);
            List<Opcion> rhsOpcionesRespuestaConsultaAcusePdf;
            rhsOpcionesRespuestaConsultaAcusePdf = ((that.opcionesRespuestaConsultaAcusePdf!= null)?that.getOpcionesRespuestaConsultaAcusePdf():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "opcionesRespuestaConsultaAcusePdf", lhsOpcionesRespuestaConsultaAcusePdf), LocatorUtils.property(thatLocator, "opcionesRespuestaConsultaAcusePdf", rhsOpcionesRespuestaConsultaAcusePdf), lhsOpcionesRespuestaConsultaAcusePdf, rhsOpcionesRespuestaConsultaAcusePdf)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        {
            String theCodigoRespuesta;
            theCodigoRespuesta = this.getCodigoRespuesta();
            strategy.appendField(locator, this, "codigoRespuesta", buffer, theCodigoRespuesta);
        }
        {
            String theDescripcionRespuesta;
            theDescripcionRespuesta = this.getDescripcionRespuesta();
            strategy.appendField(locator, this, "descripcionRespuesta", buffer, theDescripcionRespuesta);
        }
        {
            AcusePdf theAcusePdf;
            theAcusePdf = this.getAcusePdf();
            strategy.appendField(locator, this, "acusePdf", buffer, theAcusePdf);
        }
        {
            List<Opcion> theOpcionesRespuestaConsultaAcusePdf;
            theOpcionesRespuestaConsultaAcusePdf = ((this.opcionesRespuestaConsultaAcusePdf!= null)?this.getOpcionesRespuestaConsultaAcusePdf():null);
            strategy.appendField(locator, this, "opcionesRespuestaConsultaAcusePdf", buffer, theOpcionesRespuestaConsultaAcusePdf);
        }
        return buffer;
    }

}
