
package es.gob.administracion.punto_unico_notificaciones.respuestalocaliza;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlSchemaType;
import javax.xml.bind.annotation.XmlType;
import javax.xml.datatype.XMLGregorianCalendar;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * &lt;p&gt;Clase Java para Envio complex type.
 * 
 * &lt;p&gt;El siguiente fragmento de esquema especifica el contenido que se espera que haya en esta clase.
 * 
 * &lt;pre&gt;
 * &amp;lt;complexType name="Envio"&amp;gt;
 *   &amp;lt;complexContent&amp;gt;
 *     &amp;lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&amp;gt;
 *       &amp;lt;sequence&amp;gt;
 *         &amp;lt;element name="identificador" type="{http://www.w3.org/2001/XMLSchema}string"/&amp;gt;
 *         &amp;lt;element name="codigoOrigen" type="{http://www.w3.org/2001/XMLSchema}integer"/&amp;gt;
 *         &amp;lt;element name="concepto"&amp;gt;
 *           &amp;lt;simpleType&amp;gt;
 *             &amp;lt;restriction base="{http://www.w3.org/2001/XMLSchema}string"&amp;gt;
 *               &amp;lt;whiteSpace value="preserve"/&amp;gt;
 *               &amp;lt;maxLength value="255"/&amp;gt;
 *             &amp;lt;/restriction&amp;gt;
 *           &amp;lt;/simpleType&amp;gt;
 *         &amp;lt;/element&amp;gt;
 *         &amp;lt;element name="descripcion" minOccurs="0"&amp;gt;
 *           &amp;lt;simpleType&amp;gt;
 *             &amp;lt;restriction base="{http://www.w3.org/2001/XMLSchema}string"&amp;gt;
 *               &amp;lt;whiteSpace value="preserve"/&amp;gt;
 *               &amp;lt;maxLength value="1000"/&amp;gt;
 *             &amp;lt;/restriction&amp;gt;
 *           &amp;lt;/simpleType&amp;gt;
 *         &amp;lt;/element&amp;gt;
 *         &amp;lt;element name="organismoEmisor" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaLocaliza}Organismo"/&amp;gt;
 *         &amp;lt;element name="organismoEmisorRaiz" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaLocaliza}Organismo"/&amp;gt;
 *         &amp;lt;element name="fechaPuestaDisposicion" type="{http://www.w3.org/2001/XMLSchema}dateTime"/&amp;gt;
 *         &amp;lt;element name="tipoEnvio" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaLocaliza}TipoEnvio"/&amp;gt;
 *         &amp;lt;element name="vinculo" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaLocaliza}Vinculo"/&amp;gt;
 *         &amp;lt;element name="titular" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaLocaliza}Persona"/&amp;gt;
 *         &amp;lt;element name="metadatosPublicos" minOccurs="0"&amp;gt;
 *           &amp;lt;simpleType&amp;gt;
 *             &amp;lt;restriction base="{http://www.w3.org/2001/XMLSchema}string"&amp;gt;
 *               &amp;lt;whiteSpace value="preserve"/&amp;gt;
 *               &amp;lt;maxLength value="255"/&amp;gt;
 *             &amp;lt;/restriction&amp;gt;
 *           &amp;lt;/simpleType&amp;gt;
 *         &amp;lt;/element&amp;gt;
 *         &amp;lt;element name="opcionesEnvio" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaLocaliza}Opciones" minOccurs="0"/&amp;gt;
 *       &amp;lt;/sequence&amp;gt;
 *     &amp;lt;/restriction&amp;gt;
 *   &amp;lt;/complexContent&amp;gt;
 * &amp;lt;/complexType&amp;gt;
 * &lt;/pre&gt;
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Envio", propOrder = {
    "identificador",
    "codigoOrigen",
    "concepto",
    "descripcion",
    "organismoEmisor",
    "organismoEmisorRaiz",
    "fechaPuestaDisposicion",
    "tipoEnvio",
    "vinculo",
    "titular",
    "metadatosPublicos",
    "opcionesEnvio"
})
public class Envio implements Equals, ToString
{

    @XmlElement(required = true)
    protected String identificador;
    @XmlElement(required = true)
    protected BigInteger codigoOrigen;
    @XmlElement(required = true)
    protected String concepto;
    protected String descripcion;
    @XmlElement(required = true)
    protected Organismo organismoEmisor;
    @XmlElement(required = true)
    protected Organismo organismoEmisorRaiz;
    @XmlElement(required = true)
    @XmlSchemaType(name = "dateTime")
    protected XMLGregorianCalendar fechaPuestaDisposicion;
    @XmlElement(required = true)
    protected BigInteger tipoEnvio;
    @XmlElement(required = true)
    protected BigInteger vinculo;
    @XmlElement(required = true)
    protected Persona titular;
    protected String metadatosPublicos;
    @XmlElementWrapper
    @XmlElement(name = "opcion", namespace = "http://administracion.gob.es/punto-unico-notificaciones/respuestaLocaliza")
    protected List<Opcion> opcionesEnvio;

    /**
     * Obtiene el valor de la propiedad identificador.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getIdentificador() {
        return identificador;
    }

    /**
     * Define el valor de la propiedad identificador.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setIdentificador(String value) {
        this.identificador = value;
    }

    /**
     * Obtiene el valor de la propiedad codigoOrigen.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getCodigoOrigen() {
        return codigoOrigen;
    }

    /**
     * Define el valor de la propiedad codigoOrigen.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setCodigoOrigen(BigInteger value) {
        this.codigoOrigen = value;
    }

    /**
     * Obtiene el valor de la propiedad concepto.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getConcepto() {
        return concepto;
    }

    /**
     * Define el valor de la propiedad concepto.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setConcepto(String value) {
        this.concepto = value;
    }

    /**
     * Obtiene el valor de la propiedad descripcion.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getDescripcion() {
        return descripcion;
    }

    /**
     * Define el valor de la propiedad descripcion.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setDescripcion(String value) {
        this.descripcion = value;
    }

    /**
     * Obtiene el valor de la propiedad organismoEmisor.
     * 
     * @return
     *     possible object is
     *     {@link Organismo }
     *     
     */
    public Organismo getOrganismoEmisor() {
        return organismoEmisor;
    }

    /**
     * Define el valor de la propiedad organismoEmisor.
     * 
     * @param value
     *     allowed object is
     *     {@link Organismo }
     *     
     */
    public void setOrganismoEmisor(Organismo value) {
        this.organismoEmisor = value;
    }

    /**
     * Obtiene el valor de la propiedad organismoEmisorRaiz.
     * 
     * @return
     *     possible object is
     *     {@link Organismo }
     *     
     */
    public Organismo getOrganismoEmisorRaiz() {
        return organismoEmisorRaiz;
    }

    /**
     * Define el valor de la propiedad organismoEmisorRaiz.
     * 
     * @param value
     *     allowed object is
     *     {@link Organismo }
     *     
     */
    public void setOrganismoEmisorRaiz(Organismo value) {
        this.organismoEmisorRaiz = value;
    }

    /**
     * Obtiene el valor de la propiedad fechaPuestaDisposicion.
     * 
     * @return
     *     possible object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public XMLGregorianCalendar getFechaPuestaDisposicion() {
        return fechaPuestaDisposicion;
    }

    /**
     * Define el valor de la propiedad fechaPuestaDisposicion.
     * 
     * @param value
     *     allowed object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public void setFechaPuestaDisposicion(XMLGregorianCalendar value) {
        this.fechaPuestaDisposicion = value;
    }

    /**
     * Obtiene el valor de la propiedad tipoEnvio.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getTipoEnvio() {
        return tipoEnvio;
    }

    /**
     * Define el valor de la propiedad tipoEnvio.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setTipoEnvio(BigInteger value) {
        this.tipoEnvio = value;
    }

    /**
     * Obtiene el valor de la propiedad vinculo.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getVinculo() {
        return vinculo;
    }

    /**
     * Define el valor de la propiedad vinculo.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setVinculo(BigInteger value) {
        this.vinculo = value;
    }

    /**
     * Obtiene el valor de la propiedad titular.
     * 
     * @return
     *     possible object is
     *     {@link Persona }
     *     
     */
    public Persona getTitular() {
        return titular;
    }

    /**
     * Define el valor de la propiedad titular.
     * 
     * @param value
     *     allowed object is
     *     {@link Persona }
     *     
     */
    public void setTitular(Persona value) {
        this.titular = value;
    }

    /**
     * Obtiene el valor de la propiedad metadatosPublicos.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getMetadatosPublicos() {
        return metadatosPublicos;
    }

    /**
     * Define el valor de la propiedad metadatosPublicos.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setMetadatosPublicos(String value) {
        this.metadatosPublicos = value;
    }

    public List<Opcion> getOpcionesEnvio() {
        if (opcionesEnvio == null) {
            opcionesEnvio = new ArrayList<Opcion>();
        }
        return opcionesEnvio;
    }

    public void setOpcionesEnvio(List<Opcion> opcionesEnvio) {
        this.opcionesEnvio = opcionesEnvio;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof Envio)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        final Envio that = ((Envio) object);
        {
            String lhsIdentificador;
            lhsIdentificador = this.getIdentificador();
            String rhsIdentificador;
            rhsIdentificador = that.getIdentificador();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "identificador", lhsIdentificador), LocatorUtils.property(thatLocator, "identificador", rhsIdentificador), lhsIdentificador, rhsIdentificador)) {
                return false;
            }
        }
        {
            BigInteger lhsCodigoOrigen;
            lhsCodigoOrigen = this.getCodigoOrigen();
            BigInteger rhsCodigoOrigen;
            rhsCodigoOrigen = that.getCodigoOrigen();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "codigoOrigen", lhsCodigoOrigen), LocatorUtils.property(thatLocator, "codigoOrigen", rhsCodigoOrigen), lhsCodigoOrigen, rhsCodigoOrigen)) {
                return false;
            }
        }
        {
            String lhsConcepto;
            lhsConcepto = this.getConcepto();
            String rhsConcepto;
            rhsConcepto = that.getConcepto();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "concepto", lhsConcepto), LocatorUtils.property(thatLocator, "concepto", rhsConcepto), lhsConcepto, rhsConcepto)) {
                return false;
            }
        }
        {
            String lhsDescripcion;
            lhsDescripcion = this.getDescripcion();
            String rhsDescripcion;
            rhsDescripcion = that.getDescripcion();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "descripcion", lhsDescripcion), LocatorUtils.property(thatLocator, "descripcion", rhsDescripcion), lhsDescripcion, rhsDescripcion)) {
                return false;
            }
        }
        {
            Organismo lhsOrganismoEmisor;
            lhsOrganismoEmisor = this.getOrganismoEmisor();
            Organismo rhsOrganismoEmisor;
            rhsOrganismoEmisor = that.getOrganismoEmisor();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "organismoEmisor", lhsOrganismoEmisor), LocatorUtils.property(thatLocator, "organismoEmisor", rhsOrganismoEmisor), lhsOrganismoEmisor, rhsOrganismoEmisor)) {
                return false;
            }
        }
        {
            Organismo lhsOrganismoEmisorRaiz;
            lhsOrganismoEmisorRaiz = this.getOrganismoEmisorRaiz();
            Organismo rhsOrganismoEmisorRaiz;
            rhsOrganismoEmisorRaiz = that.getOrganismoEmisorRaiz();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "organismoEmisorRaiz", lhsOrganismoEmisorRaiz), LocatorUtils.property(thatLocator, "organismoEmisorRaiz", rhsOrganismoEmisorRaiz), lhsOrganismoEmisorRaiz, rhsOrganismoEmisorRaiz)) {
                return false;
            }
        }
        {
            XMLGregorianCalendar lhsFechaPuestaDisposicion;
            lhsFechaPuestaDisposicion = this.getFechaPuestaDisposicion();
            XMLGregorianCalendar rhsFechaPuestaDisposicion;
            rhsFechaPuestaDisposicion = that.getFechaPuestaDisposicion();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "fechaPuestaDisposicion", lhsFechaPuestaDisposicion), LocatorUtils.property(thatLocator, "fechaPuestaDisposicion", rhsFechaPuestaDisposicion), lhsFechaPuestaDisposicion, rhsFechaPuestaDisposicion)) {
                return false;
            }
        }
        {
            BigInteger lhsTipoEnvio;
            lhsTipoEnvio = this.getTipoEnvio();
            BigInteger rhsTipoEnvio;
            rhsTipoEnvio = that.getTipoEnvio();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "tipoEnvio", lhsTipoEnvio), LocatorUtils.property(thatLocator, "tipoEnvio", rhsTipoEnvio), lhsTipoEnvio, rhsTipoEnvio)) {
                return false;
            }
        }
        {
            BigInteger lhsVinculo;
            lhsVinculo = this.getVinculo();
            BigInteger rhsVinculo;
            rhsVinculo = that.getVinculo();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "vinculo", lhsVinculo), LocatorUtils.property(thatLocator, "vinculo", rhsVinculo), lhsVinculo, rhsVinculo)) {
                return false;
            }
        }
        {
            Persona lhsTitular;
            lhsTitular = this.getTitular();
            Persona rhsTitular;
            rhsTitular = that.getTitular();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "titular", lhsTitular), LocatorUtils.property(thatLocator, "titular", rhsTitular), lhsTitular, rhsTitular)) {
                return false;
            }
        }
        {
            String lhsMetadatosPublicos;
            lhsMetadatosPublicos = this.getMetadatosPublicos();
            String rhsMetadatosPublicos;
            rhsMetadatosPublicos = that.getMetadatosPublicos();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "metadatosPublicos", lhsMetadatosPublicos), LocatorUtils.property(thatLocator, "metadatosPublicos", rhsMetadatosPublicos), lhsMetadatosPublicos, rhsMetadatosPublicos)) {
                return false;
            }
        }
        {
            List<Opcion> lhsOpcionesEnvio;
            lhsOpcionesEnvio = ((this.opcionesEnvio!= null)?this.getOpcionesEnvio():null);
            List<Opcion> rhsOpcionesEnvio;
            rhsOpcionesEnvio = ((that.opcionesEnvio!= null)?that.getOpcionesEnvio():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "opcionesEnvio", lhsOpcionesEnvio), LocatorUtils.property(thatLocator, "opcionesEnvio", rhsOpcionesEnvio), lhsOpcionesEnvio, rhsOpcionesEnvio)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        {
            String theIdentificador;
            theIdentificador = this.getIdentificador();
            strategy.appendField(locator, this, "identificador", buffer, theIdentificador);
        }
        {
            BigInteger theCodigoOrigen;
            theCodigoOrigen = this.getCodigoOrigen();
            strategy.appendField(locator, this, "codigoOrigen", buffer, theCodigoOrigen);
        }
        {
            String theConcepto;
            theConcepto = this.getConcepto();
            strategy.appendField(locator, this, "concepto", buffer, theConcepto);
        }
        {
            String theDescripcion;
            theDescripcion = this.getDescripcion();
            strategy.appendField(locator, this, "descripcion", buffer, theDescripcion);
        }
        {
            Organismo theOrganismoEmisor;
            theOrganismoEmisor = this.getOrganismoEmisor();
            strategy.appendField(locator, this, "organismoEmisor", buffer, theOrganismoEmisor);
        }
        {
            Organismo theOrganismoEmisorRaiz;
            theOrganismoEmisorRaiz = this.getOrganismoEmisorRaiz();
            strategy.appendField(locator, this, "organismoEmisorRaiz", buffer, theOrganismoEmisorRaiz);
        }
        {
            XMLGregorianCalendar theFechaPuestaDisposicion;
            theFechaPuestaDisposicion = this.getFechaPuestaDisposicion();
            strategy.appendField(locator, this, "fechaPuestaDisposicion", buffer, theFechaPuestaDisposicion);
        }
        {
            BigInteger theTipoEnvio;
            theTipoEnvio = this.getTipoEnvio();
            strategy.appendField(locator, this, "tipoEnvio", buffer, theTipoEnvio);
        }
        {
            BigInteger theVinculo;
            theVinculo = this.getVinculo();
            strategy.appendField(locator, this, "vinculo", buffer, theVinculo);
        }
        {
            Persona theTitular;
            theTitular = this.getTitular();
            strategy.appendField(locator, this, "titular", buffer, theTitular);
        }
        {
            String theMetadatosPublicos;
            theMetadatosPublicos = this.getMetadatosPublicos();
            strategy.appendField(locator, this, "metadatosPublicos", buffer, theMetadatosPublicos);
        }
        {
            List<Opcion> theOpcionesEnvio;
            theOpcionesEnvio = ((this.opcionesEnvio!= null)?this.getOpcionesEnvio():null);
            strategy.appendField(locator, this, "opcionesEnvio", buffer, theOpcionesEnvio);
        }
        return buffer;
    }

}
