
package es.gob.administracion.punto_unico_notificaciones.respuestalocaliza;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * &lt;p&gt;Clase Java para Persona complex type.
 * 
 * &lt;p&gt;El siguiente fragmento de esquema especifica el contenido que se espera que haya en esta clase.
 * 
 * &lt;pre&gt;
 * &amp;lt;complexType name="Persona"&amp;gt;
 *   &amp;lt;complexContent&amp;gt;
 *     &amp;lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&amp;gt;
 *       &amp;lt;sequence&amp;gt;
 *         &amp;lt;element name="nombreTitular" type="{http://www.w3.org/2001/XMLSchema}string"/&amp;gt;
 *         &amp;lt;element name="nifTitular" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaLocaliza}Nif"/&amp;gt;
 *         &amp;lt;element name="codigoDIR3" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaLocaliza}CodigoOrganismo" minOccurs="0"/&amp;gt;
 *         &amp;lt;element name="codigoDIRe" type="{http://www.w3.org/2001/XMLSchema}string" minOccurs="0"/&amp;gt;
 *         &amp;lt;element name="descripcionEntidad" type="{http://www.w3.org/2001/XMLSchema}string" minOccurs="0"/&amp;gt;
 *       &amp;lt;/sequence&amp;gt;
 *     &amp;lt;/restriction&amp;gt;
 *   &amp;lt;/complexContent&amp;gt;
 * &amp;lt;/complexType&amp;gt;
 * &lt;/pre&gt;
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Persona", propOrder = {
    "nombreTitular",
    "nifTitular",
    "codigoDIR3",
    "codigoDIRe",
    "descripcionEntidad"
})
public class Persona implements Equals, ToString
{

    @XmlElement(required = true)
    protected String nombreTitular;
    @XmlElement(required = true)
    protected String nifTitular;
    protected String codigoDIR3;
    protected String codigoDIRe;
    protected String descripcionEntidad;

    /**
     * Obtiene el valor de la propiedad nombreTitular.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getNombreTitular() {
        return nombreTitular;
    }

    /**
     * Define el valor de la propiedad nombreTitular.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setNombreTitular(String value) {
        this.nombreTitular = value;
    }

    /**
     * Obtiene el valor de la propiedad nifTitular.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getNifTitular() {
        return nifTitular;
    }

    /**
     * Define el valor de la propiedad nifTitular.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setNifTitular(String value) {
        this.nifTitular = value;
    }

    /**
     * Obtiene el valor de la propiedad codigoDIR3.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getCodigoDIR3() {
        return codigoDIR3;
    }

    /**
     * Define el valor de la propiedad codigoDIR3.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setCodigoDIR3(String value) {
        this.codigoDIR3 = value;
    }

    /**
     * Obtiene el valor de la propiedad codigoDIRe.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getCodigoDIRe() {
        return codigoDIRe;
    }

    /**
     * Define el valor de la propiedad codigoDIRe.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setCodigoDIRe(String value) {
        this.codigoDIRe = value;
    }

    /**
     * Obtiene el valor de la propiedad descripcionEntidad.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getDescripcionEntidad() {
        return descripcionEntidad;
    }

    /**
     * Define el valor de la propiedad descripcionEntidad.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setDescripcionEntidad(String value) {
        this.descripcionEntidad = value;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof Persona)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        final Persona that = ((Persona) object);
        {
            String lhsNombreTitular;
            lhsNombreTitular = this.getNombreTitular();
            String rhsNombreTitular;
            rhsNombreTitular = that.getNombreTitular();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "nombreTitular", lhsNombreTitular), LocatorUtils.property(thatLocator, "nombreTitular", rhsNombreTitular), lhsNombreTitular, rhsNombreTitular)) {
                return false;
            }
        }
        {
            String lhsNifTitular;
            lhsNifTitular = this.getNifTitular();
            String rhsNifTitular;
            rhsNifTitular = that.getNifTitular();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "nifTitular", lhsNifTitular), LocatorUtils.property(thatLocator, "nifTitular", rhsNifTitular), lhsNifTitular, rhsNifTitular)) {
                return false;
            }
        }
        {
            String lhsCodigoDIR3;
            lhsCodigoDIR3 = this.getCodigoDIR3();
            String rhsCodigoDIR3;
            rhsCodigoDIR3 = that.getCodigoDIR3();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "codigoDIR3", lhsCodigoDIR3), LocatorUtils.property(thatLocator, "codigoDIR3", rhsCodigoDIR3), lhsCodigoDIR3, rhsCodigoDIR3)) {
                return false;
            }
        }
        {
            String lhsCodigoDIRe;
            lhsCodigoDIRe = this.getCodigoDIRe();
            String rhsCodigoDIRe;
            rhsCodigoDIRe = that.getCodigoDIRe();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "codigoDIRe", lhsCodigoDIRe), LocatorUtils.property(thatLocator, "codigoDIRe", rhsCodigoDIRe), lhsCodigoDIRe, rhsCodigoDIRe)) {
                return false;
            }
        }
        {
            String lhsDescripcionEntidad;
            lhsDescripcionEntidad = this.getDescripcionEntidad();
            String rhsDescripcionEntidad;
            rhsDescripcionEntidad = that.getDescripcionEntidad();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "descripcionEntidad", lhsDescripcionEntidad), LocatorUtils.property(thatLocator, "descripcionEntidad", rhsDescripcionEntidad), lhsDescripcionEntidad, rhsDescripcionEntidad)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        {
            String theNombreTitular;
            theNombreTitular = this.getNombreTitular();
            strategy.appendField(locator, this, "nombreTitular", buffer, theNombreTitular);
        }
        {
            String theNifTitular;
            theNifTitular = this.getNifTitular();
            strategy.appendField(locator, this, "nifTitular", buffer, theNifTitular);
        }
        {
            String theCodigoDIR3;
            theCodigoDIR3 = this.getCodigoDIR3();
            strategy.appendField(locator, this, "codigoDIR3", buffer, theCodigoDIR3);
        }
        {
            String theCodigoDIRe;
            theCodigoDIRe = this.getCodigoDIRe();
            strategy.appendField(locator, this, "codigoDIRe", buffer, theCodigoDIRe);
        }
        {
            String theDescripcionEntidad;
            theDescripcionEntidad = this.getDescripcionEntidad();
            strategy.appendField(locator, this, "descripcionEntidad", buffer, theDescripcionEntidad);
        }
        return buffer;
    }

}
