
package es.gob.administracion.punto_unico_notificaciones.respuestalocaliza;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * &lt;p&gt;Clase Java para RespuestaLocaliza complex type.
 * 
 * &lt;p&gt;El siguiente fragmento de esquema especifica el contenido que se espera que haya en esta clase.
 * 
 * &lt;pre&gt;
 * &amp;lt;complexType name="RespuestaLocaliza"&amp;gt;
 *   &amp;lt;complexContent&amp;gt;
 *     &amp;lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&amp;gt;
 *       &amp;lt;sequence&amp;gt;
 *         &amp;lt;element name="codigoRespuesta" type="{http://www.w3.org/2001/XMLSchema}string"/&amp;gt;
 *         &amp;lt;element name="descripcionRespuesta" type="{http://www.w3.org/2001/XMLSchema}string"/&amp;gt;
 *         &amp;lt;element name="nifPeticion"&amp;gt;
 *           &amp;lt;simpleType&amp;gt;
 *             &amp;lt;restriction base="{http://www.w3.org/2001/XMLSchema}string"&amp;gt;
 *               &amp;lt;maxLength value="9"/&amp;gt;
 *             &amp;lt;/restriction&amp;gt;
 *           &amp;lt;/simpleType&amp;gt;
 *         &amp;lt;/element&amp;gt;
 *         &amp;lt;element name="envios" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaLocaliza}Envios" minOccurs="0"/&amp;gt;
 *         &amp;lt;element name="hayMasResultados" type="{http://www.w3.org/2001/XMLSchema}boolean"/&amp;gt;
 *         &amp;lt;element name="opcionesRespuestaLocaliza" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaLocaliza}Opciones" minOccurs="0"/&amp;gt;
 *       &amp;lt;/sequence&amp;gt;
 *     &amp;lt;/restriction&amp;gt;
 *   &amp;lt;/complexContent&amp;gt;
 * &amp;lt;/complexType&amp;gt;
 * &lt;/pre&gt;
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "RespuestaLocaliza", propOrder = {
    "codigoRespuesta",
    "descripcionRespuesta",
    "nifPeticion",
    "envios",
    "hayMasResultados",
    "opcionesRespuestaLocaliza"
})
public class RespuestaLocaliza implements Equals, ToString
{

    @XmlElement(required = true)
    protected String codigoRespuesta;
    @XmlElement(required = true)
    protected String descripcionRespuesta;
    @XmlElement(required = true)
    protected String nifPeticion;
    @XmlElementWrapper
    @XmlElement(name = "item", namespace = "http://administracion.gob.es/punto-unico-notificaciones/respuestaLocaliza")
    protected List<Envio> envios;
    protected boolean hayMasResultados;
    @XmlElementWrapper
    @XmlElement(name = "opcion", namespace = "http://administracion.gob.es/punto-unico-notificaciones/respuestaLocaliza")
    protected List<Opcion> opcionesRespuestaLocaliza;

    /**
     * Obtiene el valor de la propiedad codigoRespuesta.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getCodigoRespuesta() {
        return codigoRespuesta;
    }

    /**
     * Define el valor de la propiedad codigoRespuesta.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setCodigoRespuesta(String value) {
        this.codigoRespuesta = value;
    }

    /**
     * Obtiene el valor de la propiedad descripcionRespuesta.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getDescripcionRespuesta() {
        return descripcionRespuesta;
    }

    /**
     * Define el valor de la propiedad descripcionRespuesta.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setDescripcionRespuesta(String value) {
        this.descripcionRespuesta = value;
    }

    /**
     * Obtiene el valor de la propiedad nifPeticion.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getNifPeticion() {
        return nifPeticion;
    }

    /**
     * Define el valor de la propiedad nifPeticion.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setNifPeticion(String value) {
        this.nifPeticion = value;
    }

    /**
     * Obtiene el valor de la propiedad hayMasResultados.
     * 
     */
    public boolean isHayMasResultados() {
        return hayMasResultados;
    }

    /**
     * Define el valor de la propiedad hayMasResultados.
     * 
     */
    public void setHayMasResultados(boolean value) {
        this.hayMasResultados = value;
    }

    public List<Envio> getEnvios() {
        if (envios == null) {
            envios = new ArrayList<Envio>();
        }
        return envios;
    }

    public void setEnvios(List<Envio> envios) {
        this.envios = envios;
    }

    public List<Opcion> getOpcionesRespuestaLocaliza() {
        if (opcionesRespuestaLocaliza == null) {
            opcionesRespuestaLocaliza = new ArrayList<Opcion>();
        }
        return opcionesRespuestaLocaliza;
    }

    public void setOpcionesRespuestaLocaliza(List<Opcion> opcionesRespuestaLocaliza) {
        this.opcionesRespuestaLocaliza = opcionesRespuestaLocaliza;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof RespuestaLocaliza)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        final RespuestaLocaliza that = ((RespuestaLocaliza) object);
        {
            String lhsCodigoRespuesta;
            lhsCodigoRespuesta = this.getCodigoRespuesta();
            String rhsCodigoRespuesta;
            rhsCodigoRespuesta = that.getCodigoRespuesta();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "codigoRespuesta", lhsCodigoRespuesta), LocatorUtils.property(thatLocator, "codigoRespuesta", rhsCodigoRespuesta), lhsCodigoRespuesta, rhsCodigoRespuesta)) {
                return false;
            }
        }
        {
            String lhsDescripcionRespuesta;
            lhsDescripcionRespuesta = this.getDescripcionRespuesta();
            String rhsDescripcionRespuesta;
            rhsDescripcionRespuesta = that.getDescripcionRespuesta();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "descripcionRespuesta", lhsDescripcionRespuesta), LocatorUtils.property(thatLocator, "descripcionRespuesta", rhsDescripcionRespuesta), lhsDescripcionRespuesta, rhsDescripcionRespuesta)) {
                return false;
            }
        }
        {
            String lhsNifPeticion;
            lhsNifPeticion = this.getNifPeticion();
            String rhsNifPeticion;
            rhsNifPeticion = that.getNifPeticion();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "nifPeticion", lhsNifPeticion), LocatorUtils.property(thatLocator, "nifPeticion", rhsNifPeticion), lhsNifPeticion, rhsNifPeticion)) {
                return false;
            }
        }
        {
            List<Envio> lhsEnvios;
            lhsEnvios = ((this.envios!= null)?this.getEnvios():null);
            List<Envio> rhsEnvios;
            rhsEnvios = ((that.envios!= null)?that.getEnvios():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "envios", lhsEnvios), LocatorUtils.property(thatLocator, "envios", rhsEnvios), lhsEnvios, rhsEnvios)) {
                return false;
            }
        }
        {
            boolean lhsHayMasResultados;
            lhsHayMasResultados = this.isHayMasResultados();
            boolean rhsHayMasResultados;
            rhsHayMasResultados = that.isHayMasResultados();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "hayMasResultados", lhsHayMasResultados), LocatorUtils.property(thatLocator, "hayMasResultados", rhsHayMasResultados), lhsHayMasResultados, rhsHayMasResultados)) {
                return false;
            }
        }
        {
            List<Opcion> lhsOpcionesRespuestaLocaliza;
            lhsOpcionesRespuestaLocaliza = ((this.opcionesRespuestaLocaliza!= null)?this.getOpcionesRespuestaLocaliza():null);
            List<Opcion> rhsOpcionesRespuestaLocaliza;
            rhsOpcionesRespuestaLocaliza = ((that.opcionesRespuestaLocaliza!= null)?that.getOpcionesRespuestaLocaliza():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "opcionesRespuestaLocaliza", lhsOpcionesRespuestaLocaliza), LocatorUtils.property(thatLocator, "opcionesRespuestaLocaliza", rhsOpcionesRespuestaLocaliza), lhsOpcionesRespuestaLocaliza, rhsOpcionesRespuestaLocaliza)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        {
            String theCodigoRespuesta;
            theCodigoRespuesta = this.getCodigoRespuesta();
            strategy.appendField(locator, this, "codigoRespuesta", buffer, theCodigoRespuesta);
        }
        {
            String theDescripcionRespuesta;
            theDescripcionRespuesta = this.getDescripcionRespuesta();
            strategy.appendField(locator, this, "descripcionRespuesta", buffer, theDescripcionRespuesta);
        }
        {
            String theNifPeticion;
            theNifPeticion = this.getNifPeticion();
            strategy.appendField(locator, this, "nifPeticion", buffer, theNifPeticion);
        }
        {
            List<Envio> theEnvios;
            theEnvios = ((this.envios!= null)?this.getEnvios():null);
            strategy.appendField(locator, this, "envios", buffer, theEnvios);
        }
        {
            boolean theHayMasResultados;
            theHayMasResultados = this.isHayMasResultados();
            strategy.appendField(locator, this, "hayMasResultados", buffer, theHayMasResultados);
        }
        {
            List<Opcion> theOpcionesRespuestaLocaliza;
            theOpcionesRespuestaLocaliza = ((this.opcionesRespuestaLocaliza!= null)?this.getOpcionesRespuestaLocaliza():null);
            strategy.appendField(locator, this, "opcionesRespuestaLocaliza", buffer, theOpcionesRespuestaLocaliza);
        }
        return buffer;
    }

}
