
package es.gob.administracion.punto_unico_notificaciones.consultaacusepdf;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * &lt;p&gt;Clase Java para ConsultaAcusePdf complex type.
 * 
 * &lt;p&gt;El siguiente fragmento de esquema especifica el contenido que se espera que haya en esta clase.
 * 
 * &lt;pre&gt;
 * &amp;lt;complexType name="ConsultaAcusePdf"&amp;gt;
 *   &amp;lt;complexContent&amp;gt;
 *     &amp;lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&amp;gt;
 *       &amp;lt;sequence&amp;gt;
 *         &amp;lt;element name="nifReceptor" type="{http://administracion.gob.es/punto-unico-notificaciones/consultaAcusePdf}Nif"/&amp;gt;
 *         &amp;lt;element name="identificador" type="{http://administracion.gob.es/punto-unico-notificaciones/consultaAcusePdf}Identificador"/&amp;gt;
 *         &amp;lt;element name="codigoOrigen" type="{http://www.w3.org/2001/XMLSchema}integer"/&amp;gt;
 *         &amp;lt;element name="identificadorAcusePdf" type="{http://administracion.gob.es/punto-unico-notificaciones/consultaAcusePdf}IdentificadorAcusePdf"/&amp;gt;
 *         &amp;lt;element name="opcionesConsultaAcusePdf" type="{http://administracion.gob.es/punto-unico-notificaciones/consultaAcusePdf}Opciones" minOccurs="0"/&amp;gt;
 *       &amp;lt;/sequence&amp;gt;
 *     &amp;lt;/restriction&amp;gt;
 *   &amp;lt;/complexContent&amp;gt;
 * &amp;lt;/complexType&amp;gt;
 * &lt;/pre&gt;
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ConsultaAcusePdf", propOrder = {
    "nifReceptor",
    "identificador",
    "codigoOrigen",
    "identificadorAcusePdf",
    "opcionesConsultaAcusePdf"
})
public class ConsultaAcusePdf implements Equals, ToString
{

    @XmlElement(required = true)
    protected String nifReceptor;
    @XmlElement(required = true)
    protected String identificador;
    @XmlElement(required = true)
    protected BigInteger codigoOrigen;
    @XmlElement(required = true)
    protected IdentificadorAcusePdf identificadorAcusePdf;
    @XmlElementWrapper
    @XmlElement(name = "opcion", namespace = "http://administracion.gob.es/punto-unico-notificaciones/consultaAcusePdf")
    protected List<Opcion> opcionesConsultaAcusePdf;

    /**
     * Obtiene el valor de la propiedad nifReceptor.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getNifReceptor() {
        return nifReceptor;
    }

    /**
     * Define el valor de la propiedad nifReceptor.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setNifReceptor(String value) {
        this.nifReceptor = value;
    }

    /**
     * Obtiene el valor de la propiedad identificador.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getIdentificador() {
        return identificador;
    }

    /**
     * Define el valor de la propiedad identificador.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setIdentificador(String value) {
        this.identificador = value;
    }

    /**
     * Obtiene el valor de la propiedad codigoOrigen.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getCodigoOrigen() {
        return codigoOrigen;
    }

    /**
     * Define el valor de la propiedad codigoOrigen.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setCodigoOrigen(BigInteger value) {
        this.codigoOrigen = value;
    }

    /**
     * Obtiene el valor de la propiedad identificadorAcusePdf.
     * 
     * @return
     *     possible object is
     *     {@link IdentificadorAcusePdf }
     *     
     */
    public IdentificadorAcusePdf getIdentificadorAcusePdf() {
        return identificadorAcusePdf;
    }

    /**
     * Define el valor de la propiedad identificadorAcusePdf.
     * 
     * @param value
     *     allowed object is
     *     {@link IdentificadorAcusePdf }
     *     
     */
    public void setIdentificadorAcusePdf(IdentificadorAcusePdf value) {
        this.identificadorAcusePdf = value;
    }

    public List<Opcion> getOpcionesConsultaAcusePdf() {
        if (opcionesConsultaAcusePdf == null) {
            opcionesConsultaAcusePdf = new ArrayList<Opcion>();
        }
        return opcionesConsultaAcusePdf;
    }

    public void setOpcionesConsultaAcusePdf(List<Opcion> opcionesConsultaAcusePdf) {
        this.opcionesConsultaAcusePdf = opcionesConsultaAcusePdf;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof ConsultaAcusePdf)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        final ConsultaAcusePdf that = ((ConsultaAcusePdf) object);
        {
            String lhsNifReceptor;
            lhsNifReceptor = this.getNifReceptor();
            String rhsNifReceptor;
            rhsNifReceptor = that.getNifReceptor();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "nifReceptor", lhsNifReceptor), LocatorUtils.property(thatLocator, "nifReceptor", rhsNifReceptor), lhsNifReceptor, rhsNifReceptor)) {
                return false;
            }
        }
        {
            String lhsIdentificador;
            lhsIdentificador = this.getIdentificador();
            String rhsIdentificador;
            rhsIdentificador = that.getIdentificador();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "identificador", lhsIdentificador), LocatorUtils.property(thatLocator, "identificador", rhsIdentificador), lhsIdentificador, rhsIdentificador)) {
                return false;
            }
        }
        {
            BigInteger lhsCodigoOrigen;
            lhsCodigoOrigen = this.getCodigoOrigen();
            BigInteger rhsCodigoOrigen;
            rhsCodigoOrigen = that.getCodigoOrigen();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "codigoOrigen", lhsCodigoOrigen), LocatorUtils.property(thatLocator, "codigoOrigen", rhsCodigoOrigen), lhsCodigoOrigen, rhsCodigoOrigen)) {
                return false;
            }
        }
        {
            IdentificadorAcusePdf lhsIdentificadorAcusePdf;
            lhsIdentificadorAcusePdf = this.getIdentificadorAcusePdf();
            IdentificadorAcusePdf rhsIdentificadorAcusePdf;
            rhsIdentificadorAcusePdf = that.getIdentificadorAcusePdf();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "identificadorAcusePdf", lhsIdentificadorAcusePdf), LocatorUtils.property(thatLocator, "identificadorAcusePdf", rhsIdentificadorAcusePdf), lhsIdentificadorAcusePdf, rhsIdentificadorAcusePdf)) {
                return false;
            }
        }
        {
            List<Opcion> lhsOpcionesConsultaAcusePdf;
            lhsOpcionesConsultaAcusePdf = ((this.opcionesConsultaAcusePdf!= null)?this.getOpcionesConsultaAcusePdf():null);
            List<Opcion> rhsOpcionesConsultaAcusePdf;
            rhsOpcionesConsultaAcusePdf = ((that.opcionesConsultaAcusePdf!= null)?that.getOpcionesConsultaAcusePdf():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "opcionesConsultaAcusePdf", lhsOpcionesConsultaAcusePdf), LocatorUtils.property(thatLocator, "opcionesConsultaAcusePdf", rhsOpcionesConsultaAcusePdf), lhsOpcionesConsultaAcusePdf, rhsOpcionesConsultaAcusePdf)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        {
            String theNifReceptor;
            theNifReceptor = this.getNifReceptor();
            strategy.appendField(locator, this, "nifReceptor", buffer, theNifReceptor);
        }
        {
            String theIdentificador;
            theIdentificador = this.getIdentificador();
            strategy.appendField(locator, this, "identificador", buffer, theIdentificador);
        }
        {
            BigInteger theCodigoOrigen;
            theCodigoOrigen = this.getCodigoOrigen();
            strategy.appendField(locator, this, "codigoOrigen", buffer, theCodigoOrigen);
        }
        {
            IdentificadorAcusePdf theIdentificadorAcusePdf;
            theIdentificadorAcusePdf = this.getIdentificadorAcusePdf();
            strategy.appendField(locator, this, "identificadorAcusePdf", buffer, theIdentificadorAcusePdf);
        }
        {
            List<Opcion> theOpcionesConsultaAcusePdf;
            theOpcionesConsultaAcusePdf = ((this.opcionesConsultaAcusePdf!= null)?this.getOpcionesConsultaAcusePdf():null);
            strategy.appendField(locator, this, "opcionesConsultaAcusePdf", buffer, theOpcionesConsultaAcusePdf);
        }
        return buffer;
    }

}
