
package es.gob.administracion.punto_unico_notificaciones.localiza;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlSchemaType;
import javax.xml.bind.annotation.XmlType;
import javax.xml.datatype.XMLGregorianCalendar;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * &lt;p&gt;Clase Java para Localiza complex type.
 * 
 * &lt;p&gt;El siguiente fragmento de esquema especifica el contenido que se espera que haya en esta clase.
 * 
 * &lt;pre&gt;
 * &amp;lt;complexType name="Localiza"&amp;gt;
 *   &amp;lt;complexContent&amp;gt;
 *     &amp;lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&amp;gt;
 *       &amp;lt;sequence&amp;gt;
 *         &amp;lt;element name="nifTitular" type="{http://administracion.gob.es/punto-unico-notificaciones/localiza}Nif" minOccurs="0"/&amp;gt;
 *         &amp;lt;element name="nifDestinatario" type="{http://administracion.gob.es/punto-unico-notificaciones/localiza}Nif" minOccurs="0"/&amp;gt;
 *         &amp;lt;element name="codigoDestino" type="{http://www.w3.org/2001/XMLSchema}string" minOccurs="0"/&amp;gt;
 *         &amp;lt;element name="fechaDesde" type="{http://www.w3.org/2001/XMLSchema}dateTime" minOccurs="0"/&amp;gt;
 *         &amp;lt;element name="fechaHasta" type="{http://www.w3.org/2001/XMLSchema}dateTime" minOccurs="0"/&amp;gt;
 *         &amp;lt;element name="tipoEnvio" type="{http://administracion.gob.es/punto-unico-notificaciones/localiza}TipoEnvio" minOccurs="0"/&amp;gt;
 *         &amp;lt;element name="opcionesLocaliza" type="{http://administracion.gob.es/punto-unico-notificaciones/localiza}Opciones" minOccurs="0"/&amp;gt;
 *       &amp;lt;/sequence&amp;gt;
 *     &amp;lt;/restriction&amp;gt;
 *   &amp;lt;/complexContent&amp;gt;
 * &amp;lt;/complexType&amp;gt;
 * &lt;/pre&gt;
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Localiza", propOrder = {
    "nifTitular",
    "nifDestinatario",
    "codigoDestino",
    "fechaDesde",
    "fechaHasta",
    "tipoEnvio",
    "opcionesLocaliza"
})
public class Localiza implements Equals, ToString
{

    protected String nifTitular;
    protected String nifDestinatario;
    protected String codigoDestino;
    @XmlSchemaType(name = "dateTime")
    protected XMLGregorianCalendar fechaDesde;
    @XmlSchemaType(name = "dateTime")
    protected XMLGregorianCalendar fechaHasta;
    protected BigInteger tipoEnvio;
    @XmlElementWrapper
    @XmlElement(name = "opcion", namespace = "http://administracion.gob.es/punto-unico-notificaciones/localiza")
    protected List<Opcion> opcionesLocaliza;

    /**
     * Obtiene el valor de la propiedad nifTitular.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getNifTitular() {
        return nifTitular;
    }

    /**
     * Define el valor de la propiedad nifTitular.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setNifTitular(String value) {
        this.nifTitular = value;
    }

    /**
     * Obtiene el valor de la propiedad nifDestinatario.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getNifDestinatario() {
        return nifDestinatario;
    }

    /**
     * Define el valor de la propiedad nifDestinatario.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setNifDestinatario(String value) {
        this.nifDestinatario = value;
    }

    /**
     * Obtiene el valor de la propiedad codigoDestino.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getCodigoDestino() {
        return codigoDestino;
    }

    /**
     * Define el valor de la propiedad codigoDestino.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setCodigoDestino(String value) {
        this.codigoDestino = value;
    }

    /**
     * Obtiene el valor de la propiedad fechaDesde.
     * 
     * @return
     *     possible object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public XMLGregorianCalendar getFechaDesde() {
        return fechaDesde;
    }

    /**
     * Define el valor de la propiedad fechaDesde.
     * 
     * @param value
     *     allowed object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public void setFechaDesde(XMLGregorianCalendar value) {
        this.fechaDesde = value;
    }

    /**
     * Obtiene el valor de la propiedad fechaHasta.
     * 
     * @return
     *     possible object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public XMLGregorianCalendar getFechaHasta() {
        return fechaHasta;
    }

    /**
     * Define el valor de la propiedad fechaHasta.
     * 
     * @param value
     *     allowed object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public void setFechaHasta(XMLGregorianCalendar value) {
        this.fechaHasta = value;
    }

    /**
     * Obtiene el valor de la propiedad tipoEnvio.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getTipoEnvio() {
        return tipoEnvio;
    }

    /**
     * Define el valor de la propiedad tipoEnvio.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setTipoEnvio(BigInteger value) {
        this.tipoEnvio = value;
    }

    public List<Opcion> getOpcionesLocaliza() {
        if (opcionesLocaliza == null) {
            opcionesLocaliza = new ArrayList<Opcion>();
        }
        return opcionesLocaliza;
    }

    public void setOpcionesLocaliza(List<Opcion> opcionesLocaliza) {
        this.opcionesLocaliza = opcionesLocaliza;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof Localiza)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        final Localiza that = ((Localiza) object);
        {
            String lhsNifTitular;
            lhsNifTitular = this.getNifTitular();
            String rhsNifTitular;
            rhsNifTitular = that.getNifTitular();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "nifTitular", lhsNifTitular), LocatorUtils.property(thatLocator, "nifTitular", rhsNifTitular), lhsNifTitular, rhsNifTitular)) {
                return false;
            }
        }
        {
            String lhsNifDestinatario;
            lhsNifDestinatario = this.getNifDestinatario();
            String rhsNifDestinatario;
            rhsNifDestinatario = that.getNifDestinatario();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "nifDestinatario", lhsNifDestinatario), LocatorUtils.property(thatLocator, "nifDestinatario", rhsNifDestinatario), lhsNifDestinatario, rhsNifDestinatario)) {
                return false;
            }
        }
        {
            String lhsCodigoDestino;
            lhsCodigoDestino = this.getCodigoDestino();
            String rhsCodigoDestino;
            rhsCodigoDestino = that.getCodigoDestino();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "codigoDestino", lhsCodigoDestino), LocatorUtils.property(thatLocator, "codigoDestino", rhsCodigoDestino), lhsCodigoDestino, rhsCodigoDestino)) {
                return false;
            }
        }
        {
            XMLGregorianCalendar lhsFechaDesde;
            lhsFechaDesde = this.getFechaDesde();
            XMLGregorianCalendar rhsFechaDesde;
            rhsFechaDesde = that.getFechaDesde();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "fechaDesde", lhsFechaDesde), LocatorUtils.property(thatLocator, "fechaDesde", rhsFechaDesde), lhsFechaDesde, rhsFechaDesde)) {
                return false;
            }
        }
        {
            XMLGregorianCalendar lhsFechaHasta;
            lhsFechaHasta = this.getFechaHasta();
            XMLGregorianCalendar rhsFechaHasta;
            rhsFechaHasta = that.getFechaHasta();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "fechaHasta", lhsFechaHasta), LocatorUtils.property(thatLocator, "fechaHasta", rhsFechaHasta), lhsFechaHasta, rhsFechaHasta)) {
                return false;
            }
        }
        {
            BigInteger lhsTipoEnvio;
            lhsTipoEnvio = this.getTipoEnvio();
            BigInteger rhsTipoEnvio;
            rhsTipoEnvio = that.getTipoEnvio();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "tipoEnvio", lhsTipoEnvio), LocatorUtils.property(thatLocator, "tipoEnvio", rhsTipoEnvio), lhsTipoEnvio, rhsTipoEnvio)) {
                return false;
            }
        }
        {
            List<Opcion> lhsOpcionesLocaliza;
            lhsOpcionesLocaliza = ((this.opcionesLocaliza!= null)?this.getOpcionesLocaliza():null);
            List<Opcion> rhsOpcionesLocaliza;
            rhsOpcionesLocaliza = ((that.opcionesLocaliza!= null)?that.getOpcionesLocaliza():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "opcionesLocaliza", lhsOpcionesLocaliza), LocatorUtils.property(thatLocator, "opcionesLocaliza", rhsOpcionesLocaliza), lhsOpcionesLocaliza, rhsOpcionesLocaliza)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        {
            String theNifTitular;
            theNifTitular = this.getNifTitular();
            strategy.appendField(locator, this, "nifTitular", buffer, theNifTitular);
        }
        {
            String theNifDestinatario;
            theNifDestinatario = this.getNifDestinatario();
            strategy.appendField(locator, this, "nifDestinatario", buffer, theNifDestinatario);
        }
        {
            String theCodigoDestino;
            theCodigoDestino = this.getCodigoDestino();
            strategy.appendField(locator, this, "codigoDestino", buffer, theCodigoDestino);
        }
        {
            XMLGregorianCalendar theFechaDesde;
            theFechaDesde = this.getFechaDesde();
            strategy.appendField(locator, this, "fechaDesde", buffer, theFechaDesde);
        }
        {
            XMLGregorianCalendar theFechaHasta;
            theFechaHasta = this.getFechaHasta();
            strategy.appendField(locator, this, "fechaHasta", buffer, theFechaHasta);
        }
        {
            BigInteger theTipoEnvio;
            theTipoEnvio = this.getTipoEnvio();
            strategy.appendField(locator, this, "tipoEnvio", buffer, theTipoEnvio);
        }
        {
            List<Opcion> theOpcionesLocaliza;
            theOpcionesLocaliza = ((this.opcionesLocaliza!= null)?this.getOpcionesLocaliza():null);
            strategy.appendField(locator, this, "opcionesLocaliza", buffer, theOpcionesLocaliza);
        }
        return buffer;
    }

}
