
package es.gob.administracion.punto_unico_notificaciones.respuestaconsultaanexos;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * &lt;p&gt;Clase Java para RespuestaConsultaAnexos complex type.
 * 
 * &lt;p&gt;El siguiente fragmento de esquema especifica el contenido que se espera que haya en esta clase.
 * 
 * &lt;pre&gt;
 * &amp;lt;complexType name="RespuestaConsultaAnexos"&amp;gt;
 *   &amp;lt;complexContent&amp;gt;
 *     &amp;lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&amp;gt;
 *       &amp;lt;sequence&amp;gt;
 *         &amp;lt;element name="codigoRespuesta" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaConsultaAnexos}Codigo"/&amp;gt;
 *         &amp;lt;element name="descripcionRespuesta" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaConsultaAnexos}Descripcion"/&amp;gt;
 *         &amp;lt;element name="documento" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaConsultaAnexos}DocumentoAnexo" minOccurs="0"/&amp;gt;
 *         &amp;lt;element name="opcionesRespuestaConsultaAnexo" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaConsultaAnexos}Opciones" minOccurs="0"/&amp;gt;
 *       &amp;lt;/sequence&amp;gt;
 *     &amp;lt;/restriction&amp;gt;
 *   &amp;lt;/complexContent&amp;gt;
 * &amp;lt;/complexType&amp;gt;
 * &lt;/pre&gt;
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "RespuestaConsultaAnexos", propOrder = {
    "codigoRespuesta",
    "descripcionRespuesta",
    "documento",
    "opcionesRespuestaConsultaAnexo"
})
public class RespuestaConsultaAnexos implements Equals, ToString
{

    @XmlElement(required = true)
    protected String codigoRespuesta;
    @XmlElement(required = true)
    protected String descripcionRespuesta;
    protected DocumentoAnexo documento;
    @XmlElementWrapper
    @XmlElement(name = "opcion", namespace = "http://administracion.gob.es/punto-unico-notificaciones/respuestaConsultaAnexos")
    protected List<Opcion> opcionesRespuestaConsultaAnexo;

    /**
     * Obtiene el valor de la propiedad codigoRespuesta.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getCodigoRespuesta() {
        return codigoRespuesta;
    }

    /**
     * Define el valor de la propiedad codigoRespuesta.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setCodigoRespuesta(String value) {
        this.codigoRespuesta = value;
    }

    /**
     * Obtiene el valor de la propiedad descripcionRespuesta.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getDescripcionRespuesta() {
        return descripcionRespuesta;
    }

    /**
     * Define el valor de la propiedad descripcionRespuesta.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setDescripcionRespuesta(String value) {
        this.descripcionRespuesta = value;
    }

    /**
     * Obtiene el valor de la propiedad documento.
     * 
     * @return
     *     possible object is
     *     {@link DocumentoAnexo }
     *     
     */
    public DocumentoAnexo getDocumento() {
        return documento;
    }

    /**
     * Define el valor de la propiedad documento.
     * 
     * @param value
     *     allowed object is
     *     {@link DocumentoAnexo }
     *     
     */
    public void setDocumento(DocumentoAnexo value) {
        this.documento = value;
    }

    public List<Opcion> getOpcionesRespuestaConsultaAnexo() {
        if (opcionesRespuestaConsultaAnexo == null) {
            opcionesRespuestaConsultaAnexo = new ArrayList<Opcion>();
        }
        return opcionesRespuestaConsultaAnexo;
    }

    public void setOpcionesRespuestaConsultaAnexo(List<Opcion> opcionesRespuestaConsultaAnexo) {
        this.opcionesRespuestaConsultaAnexo = opcionesRespuestaConsultaAnexo;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof RespuestaConsultaAnexos)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        final RespuestaConsultaAnexos that = ((RespuestaConsultaAnexos) object);
        {
            String lhsCodigoRespuesta;
            lhsCodigoRespuesta = this.getCodigoRespuesta();
            String rhsCodigoRespuesta;
            rhsCodigoRespuesta = that.getCodigoRespuesta();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "codigoRespuesta", lhsCodigoRespuesta), LocatorUtils.property(thatLocator, "codigoRespuesta", rhsCodigoRespuesta), lhsCodigoRespuesta, rhsCodigoRespuesta)) {
                return false;
            }
        }
        {
            String lhsDescripcionRespuesta;
            lhsDescripcionRespuesta = this.getDescripcionRespuesta();
            String rhsDescripcionRespuesta;
            rhsDescripcionRespuesta = that.getDescripcionRespuesta();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "descripcionRespuesta", lhsDescripcionRespuesta), LocatorUtils.property(thatLocator, "descripcionRespuesta", rhsDescripcionRespuesta), lhsDescripcionRespuesta, rhsDescripcionRespuesta)) {
                return false;
            }
        }
        {
            DocumentoAnexo lhsDocumento;
            lhsDocumento = this.getDocumento();
            DocumentoAnexo rhsDocumento;
            rhsDocumento = that.getDocumento();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "documento", lhsDocumento), LocatorUtils.property(thatLocator, "documento", rhsDocumento), lhsDocumento, rhsDocumento)) {
                return false;
            }
        }
        {
            List<Opcion> lhsOpcionesRespuestaConsultaAnexo;
            lhsOpcionesRespuestaConsultaAnexo = ((this.opcionesRespuestaConsultaAnexo!= null)?this.getOpcionesRespuestaConsultaAnexo():null);
            List<Opcion> rhsOpcionesRespuestaConsultaAnexo;
            rhsOpcionesRespuestaConsultaAnexo = ((that.opcionesRespuestaConsultaAnexo!= null)?that.getOpcionesRespuestaConsultaAnexo():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "opcionesRespuestaConsultaAnexo", lhsOpcionesRespuestaConsultaAnexo), LocatorUtils.property(thatLocator, "opcionesRespuestaConsultaAnexo", rhsOpcionesRespuestaConsultaAnexo), lhsOpcionesRespuestaConsultaAnexo, rhsOpcionesRespuestaConsultaAnexo)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        {
            String theCodigoRespuesta;
            theCodigoRespuesta = this.getCodigoRespuesta();
            strategy.appendField(locator, this, "codigoRespuesta", buffer, theCodigoRespuesta);
        }
        {
            String theDescripcionRespuesta;
            theDescripcionRespuesta = this.getDescripcionRespuesta();
            strategy.appendField(locator, this, "descripcionRespuesta", buffer, theDescripcionRespuesta);
        }
        {
            DocumentoAnexo theDocumento;
            theDocumento = this.getDocumento();
            strategy.appendField(locator, this, "documento", buffer, theDocumento);
        }
        {
            List<Opcion> theOpcionesRespuestaConsultaAnexo;
            theOpcionesRespuestaConsultaAnexo = ((this.opcionesRespuestaConsultaAnexo!= null)?this.getOpcionesRespuestaConsultaAnexo():null);
            strategy.appendField(locator, this, "opcionesRespuestaConsultaAnexo", buffer, theOpcionesRespuestaConsultaAnexo);
        }
        return buffer;
    }

}
