
package es.gob.administracion.punto_unico_notificaciones.respuestapeticionacceso;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlSchemaType;
import javax.xml.bind.annotation.XmlType;
import javax.xml.datatype.XMLGregorianCalendar;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * &lt;p&gt;Clase Java para RespuestaPeticionAcceso complex type.
 * 
 * &lt;p&gt;El siguiente fragmento de esquema especifica el contenido que se espera que haya en esta clase.
 * 
 * &lt;pre&gt;
 * &amp;lt;complexType name="RespuestaPeticionAcceso"&amp;gt;
 *   &amp;lt;complexContent&amp;gt;
 *     &amp;lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&amp;gt;
 *       &amp;lt;sequence&amp;gt;
 *         &amp;lt;element name="codigoRespuesta" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaPeticionAcceso}Codigo"/&amp;gt;
 *         &amp;lt;element name="descripcionRespuesta" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaPeticionAcceso}Descripcion"/&amp;gt;
 *         &amp;lt;element name="identificador" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaPeticionAcceso}Identificador"/&amp;gt;
 *         &amp;lt;element name="codigoOrigen" type="{http://www.w3.org/2001/XMLSchema}integer"/&amp;gt;
 *         &amp;lt;element name="fechaEvento" type="{http://www.w3.org/2001/XMLSchema}dateTime"/&amp;gt;
 *         &amp;lt;element name="documento" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaPeticionAcceso}DetalleDocumento" minOccurs="0"/&amp;gt;
 *         &amp;lt;element name="anexos" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaPeticionAcceso}Anexos" minOccurs="0"/&amp;gt;
 *         &amp;lt;element name="opcionesRespuestaPeticionAcceso" type="{http://administracion.gob.es/punto-unico-notificaciones/respuestaPeticionAcceso}Opciones" minOccurs="0"/&amp;gt;
 *       &amp;lt;/sequence&amp;gt;
 *     &amp;lt;/restriction&amp;gt;
 *   &amp;lt;/complexContent&amp;gt;
 * &amp;lt;/complexType&amp;gt;
 * &lt;/pre&gt;
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "RespuestaPeticionAcceso", propOrder = {
    "codigoRespuesta",
    "descripcionRespuesta",
    "identificador",
    "codigoOrigen",
    "fechaEvento",
    "documento",
    "anexos",
    "opcionesRespuestaPeticionAcceso"
})
public class RespuestaPeticionAcceso implements Equals, ToString
{

    @XmlElement(required = true)
    protected String codigoRespuesta;
    @XmlElement(required = true)
    protected String descripcionRespuesta;
    @XmlElement(required = true)
    protected String identificador;
    @XmlElement(required = true)
    protected BigInteger codigoOrigen;
    @XmlElement(required = true)
    @XmlSchemaType(name = "dateTime")
    protected XMLGregorianCalendar fechaEvento;
    protected DetalleDocumento documento;
    protected Anexos anexos;
    @XmlElementWrapper
    @XmlElement(name = "opcion", namespace = "http://administracion.gob.es/punto-unico-notificaciones/respuestaPeticionAcceso")
    protected List<Opcion> opcionesRespuestaPeticionAcceso;

    /**
     * Obtiene el valor de la propiedad codigoRespuesta.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getCodigoRespuesta() {
        return codigoRespuesta;
    }

    /**
     * Define el valor de la propiedad codigoRespuesta.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setCodigoRespuesta(String value) {
        this.codigoRespuesta = value;
    }

    /**
     * Obtiene el valor de la propiedad descripcionRespuesta.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getDescripcionRespuesta() {
        return descripcionRespuesta;
    }

    /**
     * Define el valor de la propiedad descripcionRespuesta.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setDescripcionRespuesta(String value) {
        this.descripcionRespuesta = value;
    }

    /**
     * Obtiene el valor de la propiedad identificador.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getIdentificador() {
        return identificador;
    }

    /**
     * Define el valor de la propiedad identificador.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setIdentificador(String value) {
        this.identificador = value;
    }

    /**
     * Obtiene el valor de la propiedad codigoOrigen.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getCodigoOrigen() {
        return codigoOrigen;
    }

    /**
     * Define el valor de la propiedad codigoOrigen.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setCodigoOrigen(BigInteger value) {
        this.codigoOrigen = value;
    }

    /**
     * Obtiene el valor de la propiedad fechaEvento.
     * 
     * @return
     *     possible object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public XMLGregorianCalendar getFechaEvento() {
        return fechaEvento;
    }

    /**
     * Define el valor de la propiedad fechaEvento.
     * 
     * @param value
     *     allowed object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public void setFechaEvento(XMLGregorianCalendar value) {
        this.fechaEvento = value;
    }

    /**
     * Obtiene el valor de la propiedad documento.
     * 
     * @return
     *     possible object is
     *     {@link DetalleDocumento }
     *     
     */
    public DetalleDocumento getDocumento() {
        return documento;
    }

    /**
     * Define el valor de la propiedad documento.
     * 
     * @param value
     *     allowed object is
     *     {@link DetalleDocumento }
     *     
     */
    public void setDocumento(DetalleDocumento value) {
        this.documento = value;
    }

    /**
     * Obtiene el valor de la propiedad anexos.
     * 
     * @return
     *     possible object is
     *     {@link Anexos }
     *     
     */
    public Anexos getAnexos() {
        return anexos;
    }

    /**
     * Define el valor de la propiedad anexos.
     * 
     * @param value
     *     allowed object is
     *     {@link Anexos }
     *     
     */
    public void setAnexos(Anexos value) {
        this.anexos = value;
    }

    public List<Opcion> getOpcionesRespuestaPeticionAcceso() {
        if (opcionesRespuestaPeticionAcceso == null) {
            opcionesRespuestaPeticionAcceso = new ArrayList<Opcion>();
        }
        return opcionesRespuestaPeticionAcceso;
    }

    public void setOpcionesRespuestaPeticionAcceso(List<Opcion> opcionesRespuestaPeticionAcceso) {
        this.opcionesRespuestaPeticionAcceso = opcionesRespuestaPeticionAcceso;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof RespuestaPeticionAcceso)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        final RespuestaPeticionAcceso that = ((RespuestaPeticionAcceso) object);
        {
            String lhsCodigoRespuesta;
            lhsCodigoRespuesta = this.getCodigoRespuesta();
            String rhsCodigoRespuesta;
            rhsCodigoRespuesta = that.getCodigoRespuesta();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "codigoRespuesta", lhsCodigoRespuesta), LocatorUtils.property(thatLocator, "codigoRespuesta", rhsCodigoRespuesta), lhsCodigoRespuesta, rhsCodigoRespuesta)) {
                return false;
            }
        }
        {
            String lhsDescripcionRespuesta;
            lhsDescripcionRespuesta = this.getDescripcionRespuesta();
            String rhsDescripcionRespuesta;
            rhsDescripcionRespuesta = that.getDescripcionRespuesta();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "descripcionRespuesta", lhsDescripcionRespuesta), LocatorUtils.property(thatLocator, "descripcionRespuesta", rhsDescripcionRespuesta), lhsDescripcionRespuesta, rhsDescripcionRespuesta)) {
                return false;
            }
        }
        {
            String lhsIdentificador;
            lhsIdentificador = this.getIdentificador();
            String rhsIdentificador;
            rhsIdentificador = that.getIdentificador();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "identificador", lhsIdentificador), LocatorUtils.property(thatLocator, "identificador", rhsIdentificador), lhsIdentificador, rhsIdentificador)) {
                return false;
            }
        }
        {
            BigInteger lhsCodigoOrigen;
            lhsCodigoOrigen = this.getCodigoOrigen();
            BigInteger rhsCodigoOrigen;
            rhsCodigoOrigen = that.getCodigoOrigen();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "codigoOrigen", lhsCodigoOrigen), LocatorUtils.property(thatLocator, "codigoOrigen", rhsCodigoOrigen), lhsCodigoOrigen, rhsCodigoOrigen)) {
                return false;
            }
        }
        {
            XMLGregorianCalendar lhsFechaEvento;
            lhsFechaEvento = this.getFechaEvento();
            XMLGregorianCalendar rhsFechaEvento;
            rhsFechaEvento = that.getFechaEvento();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "fechaEvento", lhsFechaEvento), LocatorUtils.property(thatLocator, "fechaEvento", rhsFechaEvento), lhsFechaEvento, rhsFechaEvento)) {
                return false;
            }
        }
        {
            DetalleDocumento lhsDocumento;
            lhsDocumento = this.getDocumento();
            DetalleDocumento rhsDocumento;
            rhsDocumento = that.getDocumento();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "documento", lhsDocumento), LocatorUtils.property(thatLocator, "documento", rhsDocumento), lhsDocumento, rhsDocumento)) {
                return false;
            }
        }
        {
            Anexos lhsAnexos;
            lhsAnexos = this.getAnexos();
            Anexos rhsAnexos;
            rhsAnexos = that.getAnexos();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "anexos", lhsAnexos), LocatorUtils.property(thatLocator, "anexos", rhsAnexos), lhsAnexos, rhsAnexos)) {
                return false;
            }
        }
        {
            List<Opcion> lhsOpcionesRespuestaPeticionAcceso;
            lhsOpcionesRespuestaPeticionAcceso = ((this.opcionesRespuestaPeticionAcceso!= null)?this.getOpcionesRespuestaPeticionAcceso():null);
            List<Opcion> rhsOpcionesRespuestaPeticionAcceso;
            rhsOpcionesRespuestaPeticionAcceso = ((that.opcionesRespuestaPeticionAcceso!= null)?that.getOpcionesRespuestaPeticionAcceso():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "opcionesRespuestaPeticionAcceso", lhsOpcionesRespuestaPeticionAcceso), LocatorUtils.property(thatLocator, "opcionesRespuestaPeticionAcceso", rhsOpcionesRespuestaPeticionAcceso), lhsOpcionesRespuestaPeticionAcceso, rhsOpcionesRespuestaPeticionAcceso)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        {
            String theCodigoRespuesta;
            theCodigoRespuesta = this.getCodigoRespuesta();
            strategy.appendField(locator, this, "codigoRespuesta", buffer, theCodigoRespuesta);
        }
        {
            String theDescripcionRespuesta;
            theDescripcionRespuesta = this.getDescripcionRespuesta();
            strategy.appendField(locator, this, "descripcionRespuesta", buffer, theDescripcionRespuesta);
        }
        {
            String theIdentificador;
            theIdentificador = this.getIdentificador();
            strategy.appendField(locator, this, "identificador", buffer, theIdentificador);
        }
        {
            BigInteger theCodigoOrigen;
            theCodigoOrigen = this.getCodigoOrigen();
            strategy.appendField(locator, this, "codigoOrigen", buffer, theCodigoOrigen);
        }
        {
            XMLGregorianCalendar theFechaEvento;
            theFechaEvento = this.getFechaEvento();
            strategy.appendField(locator, this, "fechaEvento", buffer, theFechaEvento);
        }
        {
            DetalleDocumento theDocumento;
            theDocumento = this.getDocumento();
            strategy.appendField(locator, this, "documento", buffer, theDocumento);
        }
        {
            Anexos theAnexos;
            theAnexos = this.getAnexos();
            strategy.appendField(locator, this, "anexos", buffer, theAnexos);
        }
        {
            List<Opcion> theOpcionesRespuestaPeticionAcceso;
            theOpcionesRespuestaPeticionAcceso = ((this.opcionesRespuestaPeticionAcceso!= null)?this.getOpcionesRespuestaPeticionAcceso():null);
            strategy.appendField(locator, this, "opcionesRespuestaPeticionAcceso", buffer, theOpcionesRespuestaPeticionAcceso);
        }
        return buffer;
    }

}
